<?php

class Frontend_UserController extends Zend_Controller_Action {

    public function preDispatch()
    {
        $this->em = Zend_Registry::get("em");

        //desabilita o layout caso seja um XHR/Ajax
        if ($this->_request->isXmlHttpRequest() || isset($_GET['ajax']))
            Zend_Controller_Action_HelperBroker::removeHelper('Layout');

        $this->ctrl = array(
            'name' => "user",
            'class' => "Entity\User"
        );
        
        $this->view->location = "user";
    }

    public function indexAction()
    {
        BreadCrumb::clear();
        BreadCrumb::append("Usuários","/frontend/user");
        
       if(!Permission::isChecked(Permission::VIEW_USER,Resource::getCurrentUserPermissionData()))
       {
           $this->_redirect("/frontend/index/permission-denied");
       }
        
    }

    public function listAction()
    {
        $qb = $this->em->createQueryBuilder();

        $qb->from($this->ctrl["class"], "u");

        $select = "u.id,u.name,u.email,u.created_at,u.updated_at";

        $filters = array();
        $filters[] = "u.name";
        $filters[] = "u.email";
        
        die(JQGrid::getJson($qb, $this->_request, $select, $filters, "u",false));
    }

    public function addAction()
    {
        
        if(!Permission::isChecked(Permission::ADD_EDIT_USER,Resource::getCurrentUserPermissionData()))
        {
           $this->_redirect("/frontend/index/permission-denied");
        }
        
        BreadCrumb::clear();
        BreadCrumb::append("Usuários","/frontend/user");
        
        
        $data = $this->_request->getParam("data");
        $id = $data["id"];
        
        if(empty($id))
            BreadCrumb::append("Adicionar","/frontend/user/add");
        else
            BreadCrumb::append("Editar","/frontend/user/add");

        if ($this->_request->isPost()) {
            
            if (empty($id))
                $obj = new $this->ctrl["class"]();
            else
                $obj = $this->em->find($this->ctrl["class"], $id);

            $obj->syncronize($data);

            if(!is_null($data["change_password"]))
                $obj->setPassword(md5($data["password"]));
            
            try {
                $this->em->persist($obj);
                $this->em->flush();
                $this->em->clear();
                $obj = $this->em->find($this->ctrl["class"], $obj->getId());
                $this->view->data = $obj->toArray();
                $this->view->show_success = true;
            } catch (\Entity\ValidationException $e) {
                $this->view->errors = $e->getMessages();
                $this->view->data = $data;
            } catch (Exception $e) {
                die("Erro Fatal: " . $e->getMessage());
            }
        } else {
            if (!is_null($id)) {
                $obj = $this->em->find($this->ctrl["class"], $id);
                $this->view->data = $obj->toArray();
            }
        }

        //Resources
    }

    public function deleteAction()
    {

        try
        {
            $id = $this->_request->getParam("id");
            $obj = $this->em->find($this->ctrl["class"], $id);
        
            $this->em->remove($obj);
            $this->em->flush();
            die("ok");
        }
        catch(Exception $e)
        {
            die("err");
        }
    }

}
