<?php
class ConfigHelper
{
    private static $config;

    public static function load()
    {
        self::$config = new Zend_Config_Ini("config/config.ini",null,true);
        self::getParams();
    }

    public static function getParams()
    {
        $fields = self::$config->cfg->fields;
        $params = array();

        for($count = 1;$count <= $fields;$count++)
        {
            $field = array();
            $item = "field".$count;
            $field["label"] = self::$config->cfg->$item->label;
            $field["class"] = self::$config->cfg->$item->class;
            $field["name"] = self::$config->cfg->$item->name;
            $field["type"] = self::$config->cfg->$item->type;
            $field["value"] = $field["type"]=="password"?"xxxxxxxx":self::$config->$field["name"];
            $params[] = $field;
        }

        return $params;
    }

    public static function getParam($key)
    {
        return self::$config->$key;
    }

    public static function getParamAsArray($key)
    {
        return explode(",",self::$config->$key);
    }    

    public static function setParam($key,$value)
    {
        if($value=="xxxxxxxx")
            return;
        
        return self::$config->$key = $value;
    }

    public static function save()
    {
        $writer = new Zend_Config_Writer_Ini(array('config'   => self::$config,
                                           'filename' => CFG_FILE));
        $writer->write();
    }

}
?>
