<?php

class App_Access extends Zend_Controller_Plugin_Abstract
{
    public function preDispatch(Zend_Controller_Request_Abstract $request)
    {

        //die('app_access');
        
        $controller = $request->getControllerName();
        $action = $request->getActionName();
        $module = $request->getModuleName();

        if($controller == 'login')
        {
            return;
	}

        $auth = Zend_Auth::getInstance();
        
        if(!$auth->hasIdentity())
        {
            $this->redirect($request);
        }
        else
        {
            $this->registerCurrentUser($auth->getIdentity());
        }
    }

    private function redirect($request)
    {
        $request->setControllerName('login')
        ->setActionName('index')
        ->setDispatched(false);
    }

    private function registerCurrentUser($identity)
    {

        $em = Zend_Registry::get('em');
        $qb = $em->createQueryBuilder();
        
        $qb->select("u")
           ->from("Entity\User","u")
           ->where("u.email=:email")
           ->setParameter("email",$identity);

        $query = $qb->getQuery();
        $result = $query->getResult();
        Zend_Registry::set('current_user',$result[0]);
    }
    
}