<?php

class GoogleHelper {

    private static $config;

    public static function renderGoogleAnalyticsScript() {
        ?>
        <script type="text/javascript">

            var _gaq = _gaq || [];
            _gaq.push(['_setAccount','<?php echo ExtraHelper::getParam("gaid") ?>']);
            _gaq.push(['_trackPageview']);

            (function() {
                var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
                ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
                var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
            })();

        </script>
        <?php
    }

    public static function renderGoogleMap($div,$html,$address)
    {
        ?>
        <script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>

        <script type="text/javascript">
        function initialize()
        {
            var myOptions = {
                zoom: 15,
                mapTypeId: google.maps.MapTypeId.ROADMAP
            };
            
            var map = new google.maps.Map(document.getElementById("<?php echo($div)?>"), myOptions);
            geocoder = new google.maps.Geocoder();

            geocoder.geocode({'address': '<?php echo($address)?>'}, function(results, status) {
                    if (status == google.maps.GeocoderStatus.OK) {
                        map.setCenter(results[0].geometry.location);
                        var marker = new google.maps.Marker({
                            map: map,
                            position: results[0].geometry.location
                        });
                        var infoWindow = new google.maps.InfoWindow({
                            content: '<?php echo($html)?>',
                            position: results[0].geometry.location
                        });
                        infoWindow.open(map);
                    } else {
                        alert("Geocode was not successful for the following reason: " + status);
                    }
                });
         }
        </script>

        <script type="text/javascript">
        $(document).ready(function(){
            initialize();
        });
        </script>

        <?php
    }

    public static function getDimensionList()
    {
        $list = array();

        $list["year"] = "Ano";
        $list["month"] = "Mes";
        $list["day"] = "Dia";

        return $list;
    }

    public static function getMetricList()
    {
        $list = array();

        $list["visits"] = "Visitas";
        $list["pageviews"] = "Visualizações";
        $list["visitors"] = "Visitantes";

        return $list;
    }

    public static function getStatistics($reportid,$dimensions,$metrics,$start,$end)
    {

        $ga = new gapi('joao@truevision.com.br','gamedev007');

        $ga->requestReportData($reportid,$dimensions,$metrics,null,null,$start,$end);

        //var_dump($ga->getResults());

        $data = array();
        
        foreach($ga->getResults() as $result)
        {
            $info = array();
            
            $info["label"] = "" .$result;
            
            foreach($metrics as $metric)
            {
               $method = "get" . ucfirst($metric);
               $info[$metric] = $result->$method();
            }
            $data[] = $info;
        }

        //Total
        foreach($metrics as $metric)
        {
             $method = "get" . ucfirst($metric);
             $data[$metric] = $ga->$method();
        }

        return $data;
    }

}
?>
