<?php
class JQGrid
{

    public static function getSum(Doctrine\ORM\QueryBuilder $qb,$request,$select,$filters = array(),$main_obj)
    {
        $page = $request->getParam("page");
        $limit = $request->getParam("rows");
        $sidx = $request->getParam("sidx");
        $sord = $request->getParam("sord");
        
        $_search = $request->getParam("_search");
        if($_search=="true")
        {
            foreach($filters as $filter)
            {
                $value = $request->getParam(str_replace('.',"_",$filter));
                if(!is_null($value))
                {
                    $qb->andWhere($qb->expr()->like($filter,"'%" . $value ."%'"));
                }
            }
        }
        
        // Efetua query
        $qb->select($select)
           ->orderBy($sidx,$sord);
        
        $qb->setFirstResult(null)
           ->setMaxResults(null);
        
        $query = $qb->getQuery();
	
        $rows = $query->getArrayResult();

        return $rows;
    }
    
    public static function getJson(Doctrine\ORM\QueryBuilder $qb,$request,$select,$filters = array(),$main_obj,$no_limit=true)
    {
        $page = $request->getParam("page");
        $limit = $request->getParam("rows");
        $sidx = $request->getParam("sidx");
        $sord = $request->getParam("sord");
        
        $_search = $request->getParam("_search");
        if($_search=="true")
        {
            foreach($filters as $filter)
            {
                $value = $request->getParam(str_replace('.',"_",$filter));
                if(!is_null($value))
                {
                    $qb->andWhere($qb->expr()->like($filter,"'%" . $value ."%'"));
                }
            }
        }
        
        // Efetua count / paginação
        $query = $qb->select("count(".$main_obj.") as tot")
                    ->getQuery();

        $rows = $query->getArrayResult();
        $count = $rows[0]['tot'];

        if( $count >0 )
        {
            $total_pages = ceil($count/$limit);
        }
        else
        {
            $total_pages = 0;
        }

        if ($page > $total_pages)
        {
            $page=$total_pages;
        }

        $offset = $limit*$page - $limit;
        if($offset < 0)
            $offset = 0;
        
        // Efetua query
        $qb->select($select)
            ->orderBy($sidx,$sord);
        
        if($no_limit==false)
        {
            $qb->setFirstResult($offset)
               ->setMaxResults($limit);
        }
        
        $query = $qb->getQuery();
	
	//die($query->getSql());
	
        $rows = $query->getArrayResult();
        
        $response = new stdClass();
        $response->page = $page;
        $response->total = $total_pages;
        $response->records = $count;
        $response->rows = $rows;

        //Zend_Json::$useBuiltinEncoderDecoder = true;
        //return Zend_Json::encode($response);

        return json_encode($response);
    }

    public static function getLocaleList()
    {
        $qb = Zend_Registry::get("em")->createQueryBuilder();
        $qb->select("c.id,c.name")
           ->from("Entity\Category","c")
           ->orderBy("c.name");

        $query = $qb->getQuery();

        $items = $query->getArrayResult();

        $list[] = ":todos";
        foreach($items as $item)
        {
            $list[] = $item['id'] . ':' . $item['name'];
        }

        return implode(';', $list);

    }

    public static function getCustomerList()
    {
        $qb = Zend_Registry::get("em")->createQueryBuilder();
        $qb->select("c.id,c.name")
           ->from("Entity\Customer","c")
           ->orderBy("c.name");

        $query = $qb->getQuery();

        $items = $query->getArrayResult();

        $list[] = ":todos";
        foreach($items as $item)
        {
            $list[] = $item['id'] . ':' . $item['name'];
        }

        return implode(';', $list);

    }

    public static function getSubCategoryList()
    {
        $qb = Zend_Registry::get("em")->createQueryBuilder();
        $qb->select("s.id,s.name")
           ->from("Entity\SubCategory","s")
           ->orderBy("s.name");

        $query = $qb->getQuery();

        $items = $query->getArrayResult();

        $list[] = ":todos";
        foreach($items as $item)
        {
            $list[] = $item['id'] . ':' . $item['name'];
        }

        return implode(';', $list);

    }

}
?>