<?php
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of Formatter
 *
 * @author Jox
 */
class MailHelper
{
    public static function sendMail($subject,$from,$to,$template,$params)
    {
        $app = Zend_Registry::get("app");
        
        $config = array(
            'auth' => 'login',
            'username' => $app["email"]["username"],
            'password' => $app["email"]["password"],
            'port' => $app["email"]["smtp"]["port"],
            'ssl' => 'ssl'
            );

            $transport = new Zend_Mail_Transport_Smtp($app["email"]["smtp"]["server"], $config);

            $mail = new Zend_Mail('UTF-8');
            $mail->setHeaderEncoding(Zend_Mime::ENCODING_BASE64);
            $mail->setBodyHtml(self::createMessage($template,$params));
            $mail->setFrom($app["email"]["username"]);
            $mail->addTo($to);
            $mail->setSubject($subject);
            $mail->send($transport);
    }

    public static function countUnreadMessages($ignore_cache = false)
    {
        $cache = new Zend_Session_Namespace('MailHelperCache');

        if(isset($cache->messages) && !$ignore_cache)
            return $cache->messages;
        
        $app = Zend_Registry::get("app");

        $config = array(
            'host' => $app["email"]["imap"]["server"],
            'user' => ConfigHelper::getParam("email1"),
            'password' => ConfigHelper::getParam("password1"),
            'ssl' => true
            );

        $imap = new Zend_Mail_Storage_Imap($config);
        $count = 0;
        foreach ($imap as $message)
        {
            if ($message->hasFlag(Zend_Mail_Storage::FLAG_SEEN))
                continue;
            else
                $count++;
        }

        $cache->messages = $count;
        $cache->setExpirationSeconds(300);

        return $count;
    }

    private static function createMessage($template,$params)
    {
        $msg = file_get_contents(MAIL_MSG_PATH. "/". $template);

        foreach($params as $key => $value)
        {
            $msg = str_replace($key,$value,$msg);
        }

        return $msg;
    }

}
?>