<?php
class Resource
{
    public static $customer_status_list = array(
        "0" => "Ativo",
        "1" => "Inativo"
    );
    public static $product_status_list = array(
        "1" => "Ativo",
        "0" => "Inativo"
    );
    
    public static $customer_type_list = array(
        "0" => "Juridica", 
        "1" => "Fisica"
    );
    
    public static $product_locale_list = array(
        "0" => "Campinas", 
        "1" => "Hortolandia"
    );   
    
    public static $product_measurement_unit_list = array(
        "0" => "Peça", 
        "1" => "Volume"
    );     
    
    public static $operation_list = array(
        "0" => "Compra", 
        "1" => "Venda",
        "2" => "Ajuste de Entrada",
        "3" => "Ajuste de Saida"
    ); 
    
    public static $pay_mode_list = array(
        "0" => "Dinheiro", 
        "1" => "Cartão de Crédito",
        "2" => "Cartão de Débito",
        "4" => "Boleto",
        "5" => "Cheque",
        "6" => "Vale",
        "7" => "Outros",
    );     
    
    const OPERATION_PURCHASE = 0; 
    const OPERATION_SALE = 1; 
    const OPERATION_ENTRANCE_ADJUST = 2; 
    const OPERATION_EXIT_ADJUST = 3; 
 
    public static $uf_list = array(
        "AC" => "AC",
        "AL" => "AL",
        "AM" => "AM",
        "AL" => "AL",
        "AP" => "AP",
        "BA" => "BA",
        "CE" => "CE",
        "DF" => "DF",
        "ES" => "ES",
        "ES" => "ES",
        "GO" => "GO",
        "MA" => "MA",
        "MG" => "MG",
        "MS" => "MS",
        "MT" => "MT",
        "PA" => "PA",
        "PB" => "PB",
        "PE" => "PE",
        "PI" => "PI",
        "PR" => "PR",
        "RJ" => "RJ",
        "RN" => "RN",
        "RO" => "RO",
        "RR" => "RR",
        "RS" => "RS",
        "SC" => "SC",
        "SE" => "SE",
        "SP" => "SP",
        "TO" => "TO"
    );
    
    public static function getAppName()
    {
        $app = Zend_Registry::get("app");
        return $app["name"];
    }
    
    public static function getCurrentUserPermissionData()
    {
        return Zend_Registry::get('current_user')->getPermission();
    }
    
    public static function getCurrentUserId()
    {
        return Zend_Registry::get('current_user')->getId();
    }
    
    public static function stockPop($product_id,$amount)
    {
        $em = Zend_Registry::get("em");
        $product = $em->find("Entity\Product",$product_id);
        $product->popAmount($amount);
        
        $em->persist($product);
        $em->flush();
        $em->clear();       
    }
    
    public static function stockPush($product_id,$amount)
    {
        $em = Zend_Registry::get("em");
        $product = $em->find("Entity\Product",$product_id);
        $product->pushAmount($amount);
        
        $em->persist($product);
        $em->flush();
        $em->clear();        
    }
    
    public static function getLocaleList()
    {
        
        $list[] = ":- Todos - ";
        foreach(self::$product_locale_list as $key => $value)
        {
            $list[] = $key . ':' . $value;
        }

        return implode(';', $list);

    }
    
    public static function getOperationList()
    {
        
        $list[] = ":- Todos - ";
        foreach(self::$operation_list as $key => $value)
        {
            $list[] = $key . ':' . $value;
        }

        return implode(';', $list);

    }    
    
    public static function getMeasurementUnitList()
    {
        
        $list[] = ":- Todos - ";
        foreach(self::$product_measurement_unit_list as $key => $value)
        {
            $list[] = $key . ':' . $value;
        }

        return implode(';', $list);

    }
    
    public static function getPayModeList()
    {
        
        $list[] = ":- Todos - ";
        foreach(self::$pay_mode_list as $key => $value)
        {
            $list[] = $key . ':' . $value;
        }

        return implode(';', $list);

    }    
    
    /*
    public static function getProcessList()
    {
        $qb = Zend_Registry::get("em")->createQueryBuilder();
        $qb->select("p.id,p.code")
           ->from("Entity\Process","p")
           ->orderBy("t.code");

        $query = $qb->getQuery();

        return $query->getArrayResult();
    }*/    

}
?>
